
// example of heapsort algorithm in C++

#include <iostream>
#include <vector>
#include <algorithm>

template <typename Iterator> // needs random-access iterators
void heapsort(Iterator begin, Iterator end) {
    std::make_heap(begin, end);
    std::sort_heap(begin, end);
}

int main() {
    std::vector<int> v { 3, 5, 1, 8, 2 };
    heapsort(begin(v),end(v));  // no need for std::begin due to ADL
    std::cout << "heapsort output: ";
    for(auto i: v)
        std::cout << i << " ";
    std::cout << "\n";
}
