
// compare performance of high-level lambda and for loop
// (should be the same)
// Source: Stroustrup talk, C++11 style, 2012-02

#include <vector>
#include <iostream>
#include <algorithm>

int main() {
    using vec = std::vector<int>;
    vec v(500'000'000);
    // ...
    long sum = 0;
#if defined(FOR)
    for(vec::size_type i=0; i<v.size();++i)
       sum+=v[i];
#else
    for_each(begin(v),end(v),[&sum](int x){sum+=x;});
#endif
    std::cout << sum << "\n";
}
