
// Example from ISO WG21 member: Peter Gottschling
// source: https://isocpp.org/wiki/faq/wg21
// checked by: g++-11.1 -std=c++20 icp--from-committee-members4.cc

#include <iostream>

template <typename T> inline T minimum(const T& t) { return t; }

template <typename T, typename ...P>
inline auto minimum(const T& t, const P& ...p)
{
    using res_type = std::common_type_t<T, P...>;
    return std::min(res_type(t), res_type(minimum(p...)));
}

int main() {
    std::cout << minimum(1,2,3.14,0.1) << "\n";
}

