
// source: GCC 10.2 fixed bugreports
// use: g++ -std=c++20

#include <concepts>
#include <list>
#include <ranges>

int main()
{
    std::list v {0, 1, 2, 3, 4, 5, 5, 6};    // works if std::vector

    auto view1 = v | std::views::take(5);
    auto view2 = v | std::views::transform([](int i) { return i + 3; });
    auto view3 = view1 | std::views::transform([](int i) { return i + 3; });

    std::ranges::cbegin(view1) == std::ranges::end(view1);      // works
    std::ranges::cbegin(view2) == std::ranges::end(view2);      // works
//    std::ranges::cbegin(view3) == std::ranges::end(view3); 
    return 0;
}
