
// C++ example: timing
// source: cppreference.com

#include<chrono>
#include<iostream>

size_t fib(size_t n)
{
  if (n < 2) return n;
  return fib(n - 1) + fib(n - 2);
}

int main()
{
  using namespace std;
  int const nn{42};
  auto start = chrono::high_resolution_clock::now();
  //////////////////////////////////////////////////////////////////
  auto result = fib(nn);
  //////////////////////////////////////////////////////////////////
  auto end = chrono::high_resolution_clock::now();
  cout << "fib(" << nn << ") is " << result << endl;
  cout << "Elapsed time is "
       << chrono::duration_cast<chrono::milliseconds>(end-start).count()
       << "ms" << endl;
}

