
#include <iostream>
#include <iomanip>
#include <ctime>
#include <chrono>

int main()
{
    using namespace std;
    using namespace std::chrono;

    cout << "Time point:\n";
    system_clock::time_point now = system_clock::now();
    time_t now_c = system_clock::to_time_t(now);
    time_t now_p = system_clock::to_time_t(now - hours(24));
    time_t now_e = system_clock::to_time_t(now - now.time_since_epoch());  // ==epoch
    cout << "  now is "
         << put_time(localtime(&now_c), "%F %T")
         << '\t'
         << now.time_since_epoch().count()
         << " (unit = "
         << system_clock::time_point::duration::period::num
         << '/'
         << system_clock::time_point::duration::period::den
         << " s)"
         << '\n';

    cout << "  24 hours ago, the time was "
         << put_time(localtime(&now_p), "%F %T")
         << '\n';

    cout << "  epoch: "
         << put_time(localtime(&now_e), "%F %T")
         << '\n';

    cout << "Comparison:\n"
         << "  now < system_clock::now() == "
         << (now < system_clock::now())
         << '\n'
         << "  now > system_clock::now() == "
         << (now > system_clock::now())
         << '\n';


    cout << "Timing:\n";
    steady_clock::time_point start = steady_clock::now();
    cout << "  \"Hello World\" " << flush;
    steady_clock::time_point end = steady_clock::now();
    cout << "printing took "
         << duration_cast<microseconds>(end - start).count()
         << "us.\n";

    cout << "  Unit = "
         << steady_clock::time_point::duration::period::num
         << '/'
         << steady_clock::time_point::duration::period::den
         << " s"
         << '\n';
    start = steady_clock::now();
    do { end = steady_clock::now();
    }while(start==end);
    cout << "  Resolution <= "
         << duration_cast<nanoseconds>(end - start).count()
         << "ns\n";

}
