
// test: g++ -DMETHOD

class Complex {
   double re, im;
public:
   Complex(): re(0), im(0) {}
   Complex(double r, double i=0): re(r), im(i) {}
#ifdef METHOD
   // defining binary operator + as method is problem
   Complex operator +(Complex c2) {
        return Complex(re + c2.re, im + c2.im);
   }
#else
   // better solution
   friend Complex operator +(Complex c1, Complex c2) {
        return Complex(c1.re + c2.re, c1.im + c2.im);
   }
#endif
};

int main() {
    Complex a(0,1), b(1,0), c;
    c = a + b;
#ifdef METHOD
    c = a.operator+(b);
#else
    c = operator+(a,b);
#endif
    c = Complex(5) + b;
    c = 5 + b;          // error iff METHOD defined
}
