
// source: cppreference.com
//
// badbit  irrecoverable stream error
// failbit input/output operation failed (formatting or extraction error)
// eofbit  associated input sequence has reached end-of-file 

#include <iostream>
#include <sstream>
#include <vector>
#include <array>

int main()
{
    std::istringstream input("abc|def|gh|ijkl|x");
    std::vector<std::array<char, 4>> v;

    // note: the following loop terminates when std::ios_base::operator bool()
    // on the stream returned from getline() returns false
    for (std::array<char, 4> a; input.getline(&a[0], 4, '|'); ) {
        v.push_back(a);
    }
    std::cout << "eof()=" << input.eof() << "\n";
    std::cout << "bad()=" << input.bad() << "\n";
    std::cout << "fail()=" << input.fail() << "\n";

    for (auto& a : v) {
        std::cout << &a[0] << '\n';
    }
}

