//
// simple template metaprogramming example
// ! do not use, there are better alternatives
//

#include <iostream>

// Compile-time factorial
template< unsigned n >
struct factorial
{
        static const unsigned value = n * factorial<n-1>::value;
};

template<>
struct factorial<0>
{
        static const unsigned value = 1;
};

// Run-time factorial for comparison
unsigned runtime_factorial(unsigned N)
{
        return N == 0 ? 1 : N * runtime_factorial(N - 1);
}


// TEST:

int array1[factorial<5>::value];
//int array2[runtime_factorial(5)];  // error -- not an integer constant

int main() {
  int array[runtime_factorial(5)];   // OK, possible problem with stack size limit
  std::cout << "sizeof(array) = " << sizeof(array) << std::endl;
  std::cout << std::endl;
  std::cout << "5! = " << factorial<5>::value << std::endl;
  std::cout << "5! = " << runtime_factorial(5) << std::endl;
  std::cout << std::endl;
}

