
#include <iostream>
#include <string>
#include <chrono>

int main() {

{ // in C++14, std::literals and its member namespaces are inline
   using namespace std::string_literals; // makes visible operator""s 
                                         // from
                                         // std::literals::string_literals
   auto str = "abc"s;
   std::cout << str << '\n';
}

{
   using namespace std::literals; // makes visible both
                                  // std::literals::string_literals::operator""s
                                  // and
                                  // std::literals::chrono_literals::operator""s
   auto str = "abc"s;
   auto min = 60s;
   std::cout << str << '\n';
   std::cout << min.count() << '\n';
}

{
   using std::operator""s; // makes both std::literals::string_literals::operator""s
                           // and std::literals::chrono_literals::operator""s
                           // visible
   auto str = "abc"s;
   auto min = 60s;
   std::cout << str << '\n';
   std::cout << min.count() << '\n';
}

}
