// multinh1.cc -- zkladn test nsobn ddinosti

#include <iostream>
using namespace std;

class A {
 public:
  int i;
  A(int x): i(x) { cout << "konstruktor A(" << i << ")" << endl; }
  ~A()           { cout << "destruktor  A" << endl;      }
};

class B: virtual public A { // virtuln bze
 public:
  B(): A(10) { cout << "konstruktor B()" << endl; }
  ~B()       { cout << "destruktor  B" << endl;   }
};

class B2: public A {
 public:
  B2(): A(1) { cout << "konstruktor B2()" << endl; }
  ~B2()      { cout << "destruktor  B2" << endl;   }
};

class C: virtual public A { // virtuln bze
 public:
  C(): A(20) { cout << "konstruktor C()" << endl; }
  ~C()       { cout << "destruktor  C" << endl;   }
};

class C2: public A {
 public:
  C2(): A(2) { cout << "konstruktor C2()" << endl; }
  ~C2()      { cout << "destruktor  C2" << endl;   }
};

class D: public B, public C { // pouze jedna virtuln bze A
 public:
   D(): A(30)  // voln konstruktoru virtuln bzov tdy A
             { cout << "konstruktor D()" << endl; }
   ~D()      { cout << "destruktor  D" << endl;   }
};

class D2: public B2, public C2 { // obsahuje dv bze A
 public:
   D2()      { cout << "konstruktor D2()" << endl; }
   ~D2()     { cout << "destruktor  D2" << endl;   }
};

int main() {
  cout << "***objekt D:" << endl;
  D d;
  cout << " sizeof(D) = " << sizeof(D) << endl;
  cout << "***objekt D2:" << endl;
  D2 d2;
  cout << " sizeof(D2) = " << sizeof(D2) << endl;
  d.i = 55;       // OK, m jen jedno i
  d2.B2::i = 33;  // een nejednoznanosti
  d2.C2::i = 11;
  return 0;
}
