// newdelete.cc -- petovn opertor new, delete, []
//
// program provdjte po krocch (F7 v Borland C++)
// prohldnte si obsah objektu (F4)
//
// Poznmka: program neuvauje vyvoln vjimek v opertoru new
//           a kon chybou

#include <iostream>
#include <cstdlib> // malloc(), free(), exit()
using namespace std;

void error(char *s) { 
  cerr << endl << "ERROR: " << s << endl;
  exit(1);
}

void * newalloc(size_t size) { // funkce pro dynamickou alokaci pamti
  void *ptr = malloc(size);
  if(!ptr) 
    error(" newalloc()  allocation failed");
  return ptr;
}

void newfree(void *ptr) { // funkce pro uvolnn dynamicky pidlen pamti
  free(ptr);
}

class X {  // pokusn tda
  int size;
  int *ptr;
 public:
  X(int n);
  ~X();
  void * operator new (size_t size) {  // pouze pro objekty tto tdy
    return newalloc(size);
  }
  void operator delete (void * p) {    // pouze pro objekty tto tdy
    newfree(p);
  }
  int &operator [] (int i) {
    if(i<0 || i>=size) 
      error("Index out of range");
    return ptr[i];
  }
};

X::X(int n) : size(n) {         // konstruktor X
  ptr = new int[n];
  if(!ptr)
    error(" ::new   allocation failed");
  for(int i=0; i<size; i++)     // inicializace alokovan pamti
    ptr[i] = 0;
}

X::~X() {                       // destruktor X
  delete [] ptr;
}

int main() { // test
  X *ptr = new X(5);
  X a(10);

  (*ptr)[2] = 5;
  a[1] = 356;

  // nsleduje chyba (run-time): "Index out of range"
  a[10] = 2;

  return 0;
}
