// specptr.cc -- ukazatele na leny td

#include <iostream>
using namespace std;

class Base {
 public:
  Base *Next;
  virtual void Print()   { cout << "Base "; }
  virtual void PrintNl() { cout << "Base" << endl; }
};

class A : public Base {
 public:
  void Print()   { cout << "A "; }
  void PrintNl() { cout << "A" << endl; }
};

typedef void (Base::*Tptr)(); // Tptr je ukazatel na 
                              // metodu tdy Base bez parametr

class List {                  // jednoduch seznam
  Base *First;
 public:
  List() { First=0; }
  void Insert(Base *obj) {
    obj->Next = First;
    First = obj;
  }
  void ForEach(Tptr method) { // pro vechny prvky seznamu provede metodu
    Base *p;
    for(p=First; p!=0; p=p->Next)
      (p->*method)();  // voln metody
  }
};


int main() {
  List l;
  l.Insert(new Base);
  l.Insert(new Base);
  l.Insert(new A);
  l.Insert(new Base);
  l.Insert(new A);

  cout << "------------------------------" << endl;
  l.ForEach(&Base::Print);
  cout << endl << "------------------------------" << endl;
  l.ForEach(&Base::PrintNl);
  cout << "------------------------------" << endl;

  return 0;
}

