// sstring.cc -- petovn opertoru piazen
//               a definice 'koprovacho' konstruktoru
//
// program provdjte po krocch
//

#include <cstring>
#include <iostream>
#include <cstdlib>
using namespace std;

void error(const char *s) {             // chybov hlen a konec
  cerr << endl << "ERROR: " << s << endl;
  exit(1);
}

class String { // jednoduch etzce, pouze nejnutnj operace
  char *s;                              // ukazatel na hodnotu etzce
  void alloc(int l) {
    s = new char[l+1];                  // koncov znak '\0' v etzci
    if(s==0) error("no memory");        // test (bez exceptions)
  }
  void free() { delete [] s; }
 public:
  String(const char *ss="") {           // konstruktor
    alloc(strlen(ss));                  // pidlme msto
    strcpy(s, ss);                      // naplnme hodnotou
  }
  String(const String &str) {           // copy konstruktor
    alloc(strlen(str.s));               // pidlme msto
    strcpy(s, str.s);                   // naplnme hodnotou
  }
  String &operator = (const String &str) { // opertor piazen
    if(&str==this) return(*this);       // vyeme problm a = a
    free();                             // uvolnme starou hodnotu
    alloc(strlen(str.s));               // pidlme msto
    strcpy(s, str.s);                   // naplnme novou hodnotou
    return *this;                       // vrtme referenci
  }
  ~String() {                           // musme mt destruktor
    free();                             // uvolnme hodnotu
  }
  friend ostream &operator << (ostream &stream, String &str) {
    stream << str.s ;                   // vstup etzce
    return stream;
  }
}; // class String

int main() {            // test etzc
  String s1;
  String s2("Text");
  String s3(s2);        // 'copy' konstruktor

  s1 = s2 = s3;         // piazen
  s1 = s1;              // test specilnho ppadu

  cout << "s1: " << s1 << endl;  // tisk

  return 0;
}
