// vector.cc
// pklad pouit ablony vector<T> ze standardn knihovny C++
// Peklad:  g++ vector.cc
// Bug-report mailto: peringer AT fit.vutbr.cz

#include <vector>
#include <algorithm>
#include <iostream>
#include <iterator>
using namespace std;

// tisk vektoru
void tisk(vector<int>& v) {
  ostream_iterator<int> output(cout, " "); // vstupn itertor      
  cout << "vector: ";
  copy(v.begin(), v.end(), output);        // kopie vektoru na vstup
  cout << endl;
  cout << "size: "     << v.size()     << ", "; // poet prvk
  cout << "capacity: " << v.capacity() << ", "; // pidlen pam
  cout << "max_size: " << v.max_size() << endl; // omezen implementace
  cout << endl;
}

int main() {
  const int SIZE = 5;
  static int a[SIZE] = { 1, 2, 3, 4, 5 };
  
  vector<int> v(SIZE);           // vektor s poten velikost SIZE
  tisk(v);
  
  copy(a, a+SIZE, v.begin() );   // naplnme vektor z pole (itertor
                                 // pro obyejn pole je ukazatel),
                                 // vektor mus mt velikost min. SIZE
  tisk(v);

  v.push_back(6);                // pidme jeden prvek na konec 
  tisk(v);
  
  copy(a, a+SIZE, inserter(v,v.end()) ); // pidme prvky pole na konec
  tisk(v);
  
  v.pop_back();                  // odebereme jeden prvek na konci
  tisk(v);

  cout << "v[3] = "      << v[3]      << endl;
  cout << "v.front() = " << v.front() << endl;
  cout << "v.back() = "  << v.back()  << endl;
  
  return 0;
}

