
// example of random number generation in C++11 -- bernoulli_distribution
// http://www.cplusplus.com/reference/random/bernoulli_distribution/

// The tossing of a coin is distributed according to a Bernoulli distribution
// with a probability p of approximately 0.5.


#include <iostream>
#include <random>
#include <ctime>

int main() {
    const int nrolls=100000;
    const int seed=std::time(0);        // warning - not the best seed
    std::default_random_engine  generator(seed); // base generator
    std::bernoulli_distribution bernoulli(0.5);  // transformer
    int count=0;  // count number of trues
    for (int i=0; i<nrolls; ++i)
        if (bernoulli(generator))
            ++count;
    std::cout << nrolls << " x bernoulli_distribution("<<bernoulli<<"):" << std::endl;
    std::cout << "true:  " << count << std::endl;
    std::cout << "false: " << nrolls-count << std::endl;
}
