
// Demonstrate some problems of parallel computation (C++11)
// race
// Source: http://danluu.com/new-cpu-features/

#include <iostream>
#include <thread>

const int NUM_ITERS  = 10000;
const int NUM_THREADS = 2;      // min=2

// shared data
int counter = 0;

// function to increment the counter
void asm_inc() {
    int *p_counter = &counter;
    for (int i = 0; i < NUM_ITERS; ++i) {
        __asm__("incl (%0) \n\t" : : "r" (p_counter));
    }
}

int main () {
    std::thread t[NUM_THREADS];
    for (int i = 0; i < NUM_THREADS; ++i) {
        t[i] = std::thread(asm_inc);
    }
    for (int i = 0; i < NUM_THREADS; ++i) {
        t[i].join();
    }
    std::cout << "Counter value: " << counter << "\n";
    std::cout << "Correct value: " << NUM_ITERS*NUM_THREADS << "\n";
}

